package com.loganmagnan.firstjoincommand;

import com.loganmagnan.firstjoincommand.utils.ClassRegistrationUtils;
import com.loganmagnan.firstjoincommand.utils.ColorUtils;
import com.loganmagnan.firstjoincommand.utils.command.CommandFramework;
import com.loganmagnan.firstjoincommand.utils.config.file.Config;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;

@Getter
public class FirstJoinCommand extends JavaPlugin {

    @Getter private static FirstJoinCommand instance;

    private Config mainConfig;

    private CommandFramework commandFramework = new CommandFramework(this);

    @Override
    public void onEnable() {
        instance = this;

        this.saveDefaultConfig();
        this.mainConfig = new Config("config", this);

        Bukkit.getConsoleSender().sendMessage("------------------------------------------------");
        Bukkit.getConsoleSender().sendMessage(ColorUtils.getMessageType("&bFirstJoinCommand &8- &av" + this.getDescription().getVersion()));
        Bukkit.getConsoleSender().sendMessage(ColorUtils.getMessageType("&7Made by &eLoganM Development"));
        Bukkit.getConsoleSender().sendMessage("------------------------------------------------");

        this.loadCommands();
        this.loadManagers();
        this.loadListeners();
        this.loadRunnables();
    }

    @Override
    public void onDisable() {
        instance = null;
    }

    private void loadCommands() {
        ClassRegistrationUtils.loadCommands("com.loganmagnan.firstjoincommand.commands");
    }

    private void loadManagers() {

    }

    private void loadListeners() {
        ClassRegistrationUtils.loadListeners("com.loganmagnan.firstjoincommand.listeners");
    }

    private void loadRunnables() {

    }
}
